<template>
    <div>
        <label for="name">{{ label }}</label>
        <input 
            :value="value"
            @input="$emit('input', $event.target.value)"
            @keypress="onKeypress"
            :type="type" 
            class="form-control" 
            :placeholder="placeholder" 
            required
            :autocomplete="autocomplete"
        />
        <div style="font-size: 12; color: tomato;">{{ error }}</div>
    </div>
</template>

<script>
import { numberChecker }     from './../utils/numberChecker';
import { textLengthChecker } from './../utils/textLengthChecker';

export default {

    props: {
        label: {
            type: String,
            default: "Label"
        },
        placeholder: {
            type: String,
            default: "placeholder"
        },
        value: {
            type: String,
            default: ""
        },
        error: {
            type: String,
            default: ""
        },
        onlyNumbers: {
            type: Boolean,
            default: false
        },
        limitCharacters: {
            type: Number,
            default: 0
        },
        type: {
            type: String,
            default: "text"
        },
        autocomplete: {
            type: Boolean,
            default: false
        }
    },

    data: () => {
        return {
           //
        }
    },

    methods: {
        onKeypress(event) {

            if (this.onlyNumbers) {
                numberChecker(event);
            }

            if (this.limitCharacters) {
                textLengthChecker(event, this.limitCharacters);
            }
        }
    }
}
</script>